Subject: bug#40784: Clarifying the difference between fringe bitmaps and XBM images

From: Clément Pit-Claudel <[email-masked]>
Date: Thu, 23 Apr 2020 10:35:54 -0400

On 23/04/2020 10.30, Eli Zaretskii wrote:
>> From: Clément Pit-Claudel <[email-masked]>
>> Date: Wed, 22 Apr 2020 17:52:23 -0400
>>
>> I was experimenting with XBM images today and it took me a while to realize that the bits in XBM and fringe bitmaps are not in the same order.  The attached patch attempts to highlight this.
> 
> I don't think I understand the concern, and therefore cannot make up
> my mind about the proposed changes.  Can you tell more about your
> difficulties?

Of course: I am currently writing a mode that displays indicators either in the margins or in the fringes, depending on the value of a defcustom.
By default, I intended to use the same bitmaps in the margins and in the fringes.  It took me a while to understand what I was doing wrong: I was seeing reversed bitmaps, but I hadn't considered the possibility that the two places where Emacs supports monochrome bitmaps would accept the same representation (unibyte strings) but use a different bit order. 
The proposed patch updates the documentation to save the next person from experiencing the same pain.

Clément.